code	segment	'code'
	assume	cs:code,ds:code

	org	100h

start:	mov	sp,200h			; move stack pointer
	push	ax			; push address for return to DOS

	mov	bl,20h			; resize memory block
	mov	ah,4ah
	int	21h

	mov	ax,3521h		; get current INT 21h handler
	int	21h
	mov	word ptr old21,bx
	mov	word ptr old21+2,es
	push	cs			; restore ES for EXEC
	pop	es

	mov	dx,offset new21		; install new INT 21h handler
	mov	ah,25h
	int	21h

	mov	word ptr tail+2,cs	; set segments in param block
	mov	word ptr fcb1+2,cs
	mov	word ptr fcb2+2,cs

	mov	dx,offset prog		; EXEC child process
	mov	bx,offset parm
	mov	ax,4b00h
	int	21h

	lds	dx,old21		; restore old INT 21h handler
	mov	ax,2521h
	int	21h

	ret				; return to DOS

new21:	cmp	ah,35h			; get interrupt vector?
	jne	pass

	push	bp			; save registers
	mov	bp,sp
	push	bx
	push	es
	les	bx,[bp+2]		; get return address from stack
	cmp	word ptr es:[bx+33h],0acb4h	; is it the right call?
	jne	nope

	push	ax
	mov	al,0bh			; read isr command
	out	20h,al			; on master PIC
	in	al,20h			; read isr
	test	al,1			; IRQ0 in service?
	je	back
	mov	al,15h			; MPU version
	push	cs			; push return address
	push	offset back
	push	es			; push call address
	push	word ptr es:[bx+2bh]
	retf				; "call" buffer write routine
back:	pop	ax

nope:	pop	es			; restore registers
	pop	bx
	pop	bp
pass:
	db	0eah			; far jump opcode
old21	dd	0			; old INT 21h handler address

prog	db	'GATE.EXE'		; floppy program filename
parm	dw	0			; default env seg
tail	dd	80h			; command line tail pointer
fcb1	dd	5ch			; first FCB pointer
fcb2	dd	6ch			; second FCB pointer

code	ends

	end	start
